//   Copyright 2013 Christian Gjerde Jensen

//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at

//       http://www.apache.org/licenses/LICENSE-2.0

//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

//////////////////
// NEWS HANDLER //
//////////////////

var newsHandler = function() {
  function getNews(search, count) {
    $.ajax({
      'url': 'http://vm-6120.idi.ntnu.no:8080/solr/news/select',
      'data': {'wt' : 'json', 'q' : search.toLowerCase(), 'rows' : count},
      'success': function(data) { addArticles(search, data.response.docs); },
      'dataType': 'jsonp',
      'jsonp': 'json.wrf'
    });
  }

  function addArticles(category, articles) {
    var pArticles = [];
    for (var i in articles) {
      var img;
      if (articles[i]['image-url']) {
        img = articles[i]['image-url'][0];
      } else {
        img = 'img/noimg.png';
      }
      pArticles.push({title: articles[i].title, img: img, text: articles[i]['lead-text'], link: articles[i].links[0]});
    }
    viewModel.addNews(category, pArticles);
  }

  return {
    getNews: getNews
  };
}();