//   Copyright 2013 Christian Gjerde Jensen

//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at

//       http://www.apache.org/licenses/LICENSE-2.0

//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

////////////
// SOCIAL //
////////////

var social = function() {
  var homeTown;
  var age;
  var gender;

  function setGender(val) {
    gender = val;

    if (gender === "male") {
      viewModel.addCategory("Bil", 1);
    } else if (gender === "female") {
      viewModel.addCategory("Mote", 1);
    }
  }

  function setAge(val) {
    age = val;

    if (age < 16) {
      viewModel.addCategory("Dataspill", 1);
    } else if (age < 26) {
      viewModel.addCategory("Teknologi", 1);
    } else if (age >= 26) {
      viewModel.addCategory("Politikk", 1);
    }
  }

  function setHomeTown(val) {
    homeTown = val;
    viewModel.addCategory(homeTown, 1);
  }

  return {
    setGender: setGender,
    setAge: setAge,
    setHomeTown: setHomeTown
  };
}();

var facebook = function() {
  window.fbAsyncInit = function() {
    FB.init({
      appId      : 'YOUR_APP_ID', // Replace with App ID
      channelUrl : '//WWW.URL.COM/channel.html', // Replace with URL to channel File
      status     : true, // check login status
      cookie     : true, // enable cookies to allow the server to access the session
      xfbml      : true  // parse XFBML
    });

    //Retrieve user data when already logged in
    FB.getLoginStatus(function(response) {
      if (response.status === 'connected') {
        // connected
        getFacebookData();
      } else if (response.status === 'not_authorized') {
        // not_authorized

      } else {
        // not_logged_in

      }
    });

    //Retrieve user data on login
    FB.Event.subscribe('auth.login', function(response) {
      getFacebookData();
    });
  };

  // Load the SDK Asynchronously
  (function(d){
    var js, id = 'facebook-jssdk', ref = d.getElementsByTagName('script')[0];
    if (d.getElementById(id)) {return;}
      js = d.createElement('script'); js.id = id; js.async = true;
      js.src = "//connect.facebook.net/en_US/all.js";
      ref.parentNode.insertBefore(js, ref);
  }(document));

  function logout() {
    FB.logout(function(response) {
      // user is now logged out

    });
  }

  function getFacebookData() {
    FB.api('/me', function(response) {
      if (response.birthday) {
        //Convert Facebook date string to Date object
        var splitDate = response.birthday.split("/");
        var birthDate = new Date(splitDate[2], splitDate[1]-1, splitDate[0]);
        //Find age
        var todayDate = new Date();
        age = todayDate.getFullYear() - birthDate.getFullYear();
        if (todayDate.getMonth() < birthDate.getMonth() || todayDate.getMonth() == birthDate.getMonth() && todayDate.getDate() < birthDate.getDate()) {
          age--;
        }
        social.setAge(age);
      }

      if (response.gender) {
        social.setGender(response.gender);
      }

      if (response.hometown) {
        social.setHomeTown(response.hometown.name.split(",")[0]);
      }
    });
  }

  return {

  };
}();

var gplus = function() {
  var BASE_API_PATH = 'plus/v1/';

  // Load the SDK Asynchronously
  (function() {
    var po = document.createElement('script');
    po.type = 'text/javascript'; po.async = true;
    po.src = 'https://plus.google.com/js/client:plusone.js';
    var s = document.getElementsByTagName('script')[0];
    s.parentNode.insertBefore(po, s);
  })();

  function onSignInCallback(authResult) {
    gapi.client.load('plus','v1', function(){
      if (authResult['access_token']) {
        getGplusData();
      } else if (authResult['error']) {
        // There was an error, which means the user is not signed in.

      }
    });
  }

  function disconnect() {
    // Revoke the access token.
    $.ajax({
      type: 'GET',
      url: 'https://accounts.google.com/o/oauth2/revoke?token=' + gapi.auth.getToken().access_token,
      async: false,
      contentType: 'application/json',
      dataType: 'jsonp',
      success: function(result) {
        console.log('revoke response: ' + result);
      },
      error: function(e) {
        console.log(e);
      }
    });
  }

  function getGplusData(){
    var request = gapi.client.plus.people.get( {'userId' : 'me'} );
    request.execute( function(profile) {

      if (profile.gender) {
        social.setGender(profile.gender);
      }

      if (profile.placesLived) {
        social.setHomeTown(profile.placesLived[0].value);
      }

      if (profile.birthday) {
        //Convert Facebook date string to Date object
        var splitDate = profile.birthday.split("-");
        var birthDate = new Date(splitDate[0], splitDate[1]-1, splitDate[2]);
        //Find age
        var todayDate = new Date();
        age = todayDate.getFullYear() - birthDate.getFullYear();
        if (todayDate.getMonth() < birthDate.getMonth() || todayDate.getMonth() == birthDate.getMonth() && todayDate.getDate() < birthDate.getDate()) {
          age--;
        }
        social.setAge(age);
      } else {
        social.setAge(profile.ageRange.min);
      }

      if (profile.error) {

        return;
      }
    });
  }

  return {
    onSignInCallback: onSignInCallback
  };
}();

function onSignInCallback(authResult) {
  gplus.onSignInCallback(authResult);
}